package data.missions.citadel_fighter_ship;

import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

public class MissionDefinition implements MissionDefinitionPlugin
{
	public void defineMission( MissionDefinitionAPI api )
	{
		// Set up the fleets
		api.initFleet(FleetSide.PLAYER, "CDS", FleetGoal.ATTACK, false);
		api.setFleetTagline(FleetSide.PLAYER, "Citadel Fighter Wing");
		
		api.initFleet(FleetSide.ENEMY, "ISS", FleetGoal.ATTACK, true);
		api.setFleetTagline(FleetSide.ENEMY, "Random Ship");
		
		// Nomad fighters
		api.addToFleet(FleetSide.PLAYER, "fox_arrowhead_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_arrowhead_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_arrowhead_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_arrowhead_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_arrowhead_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_arrowhead_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_heak_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_heak_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_heak_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_heak_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_heak_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_heak_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_mako_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_plasma_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_plasma_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_plasma_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_plasma_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_torp_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_torp_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_torp_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "fox_bomber_torp_wing", FleetMemberType.FIGHTER_WING, false);

		// Vanilla fighters (pick 1)
		String[] variant2Ids = {
			"eagle_Assault",
			"venture_Balanced",
			"apogee_Balanced",
			"dominator_Assault",
			"aurora_Balanced",
			"doom_Strike",
			"condor_FS",
			"medusa_Attack",
			"sunder_Assault",			
			"enforcer_Assault",
			"hammerhead_Balanced",
			"afflictor_Strike",
			"shade_Assault"	,
			"tempest_Attack",	
			"gemini_Standard",
			"buffalo2_FS",
			"lasher_Standard",
			"hyperion_Attack",		
			"vigilance_FS",
			"brawler_Assault",	
			"tempest_Attack",
			"wolf_CS",
			"astral_Elite",	
			"onslaught_Standard",
			"conquest_Elite",
			"odyssey_Balanced",
		};
		int idy = (int)(Math.random() * variant2Ids.length);
		api.addToFleet(FleetSide.ENEMY, variant2Ids[idy], FleetMemberType.SHIP, false);
		
		// Set up the map.
		float width = 8000f;
		float height = 8000f;
		api.initMap((float)-width/2f, (float)width/2f, (float)-height/2f, (float)height/2f);
	}

}
