

package data.scripts;

/**
 *FROM MESOTRONIK
 */

import com.fs.starfarer.api.AnimationAPI;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.EveryFrameWeaponEffectPlugin;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.WeaponAPI;

public class CitadelMinigunScript implements EveryFrameWeaponEffectPlugin
{
    private int curFrame = 0;
    private float timeBetweenFrames = Float.MAX_VALUE, timeSinceLastFrame = 0f;
    private boolean initiated = false;

    @Override
    public void advance(float amount, CombatEngineAPI engine, WeaponAPI weapon)
    {
        if (engine.isPaused()||weapon.getSlot().isHidden())
        {
            return;
        }

        AnimationAPI anim = weapon.getAnimation();
        ShipAPI ship = weapon.getShip();

        // Get animation framerate from .wpn file but handle the animation ourselves
        if (!initiated)
        {
            initiated = true;
            timeBetweenFrames = 1f / anim.getFrameRate();
            weapon.getAnimation().setFrameRate(0f);
        }

        // On death instantly set to frame 0
        if (ship.isHulk())
        {
            anim.setFrame(0);
            return;
        }

        // Only animate while firing, finish animation afterwards
        if (weapon.isFiring() || curFrame != 0)
        {
            timeSinceLastFrame += amount;
            while (timeSinceLastFrame >= timeBetweenFrames)
            {
                timeSinceLastFrame -= timeBetweenFrames;
                if (++curFrame >= anim.getNumFrames())
                {
                    curFrame = 0;
                }
            }
        }

        anim.setFrame(curFrame);
    }
}
