package data.scripts.world.citadel;

import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.RepLevel;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.impl.campaign.ids.Factions;
import com.fs.starfarer.api.impl.campaign.shared.SharedData;

public class DefendersGen implements SectorGeneratorPlugin{

    public void generate(SectorAPI sector) {
    
        initFactionRelationships(sector);
        SharedData.getData().getPersonBountyEventData().addParticipatingFaction("citadeldefenders");
        
        new Citadel().generate(sector);
    }

    private static void initFactionRelationships(SectorAPI sector) {

        FactionAPI citadel = sector.getFaction("citadeldefenders");

        citadel.setRelationship(Factions.HEGEMONY, RepLevel.INHOSPITABLE);
        citadel.setRelationship(Factions.TRITACHYON, RepLevel.NEUTRAL);
        citadel.setRelationship(Factions.DIKTAT, RepLevel.SUSPICIOUS);
        citadel.setRelationship(Factions.INDEPENDENT, RepLevel.COOPERATIVE);
        citadel.setRelationship(Factions.LUDDIC_CHURCH, RepLevel.INHOSPITABLE);
        citadel.setRelationship(Factions.LUDDIC_PATH, RepLevel.VENGEFUL);
        citadel.setRelationship(Factions.PLAYER, RepLevel.WELCOMING);
        citadel.setRelationship(Factions.PIRATES, RepLevel.VENGEFUL);
        citadel.setRelationship("blackrock_driveyards", RepLevel.SUSPICIOUS);
        citadel.setRelationship("shadow_industry", RepLevel.FAVORABLE);
        citadel.setRelationship("exigency", RepLevel.HOSTILE);
        citadel.setRelationship("exipirated", RepLevel.HOSTILE);
        citadel.setRelationship("templars", RepLevel.HOSTILE);
        citadel.setRelationship("mayorate", RepLevel.HOSTILE);
        citadel.setRelationship("junk_pirates", RepLevel.HOSTILE);
        citadel.setRelationship("pack", RepLevel.WELCOMING);
        citadel.setRelationship("syndicate_asp", RepLevel.FAVORABLE);

        
    }
}
