package data.shipsystems.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.plugins.ShipSystemStatsScript;

public class BerserkerStats implements ShipSystemStatsScript {

    @Override
    public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
        if (state == ShipSystemStatsScript.State.OUT) {
            stats.getMaxSpeed().unmodify(id); // to slow down ship to its regular top speed while powering drive down
            stats.getMaxTurnRate().unmodify(id);
            
        } else {
            stats.getMaxSpeed().modifyPercent(id, 33f);
            stats.getAcceleration().modifyPercent(id, 100f * effectLevel);
            stats.getDeceleration().modifyPercent(id, 100f * effectLevel);
            stats.getMissileRoFMult().modifyPercent(id, 33f);
            stats.getEnergyRoFMult().modifyPercent(id, 33f);
            stats.getBallisticRoFMult().modifyPercent(id, 33f);
            stats.getShieldDamageTakenMult().modifyMult(id, 0.5f);
            stats.getShieldUpkeepMult().modifyMult(id, 0.5f);
            stats.getShieldArcBonus().modifyPercent(id, 150f);
            stats.getBeamWeaponDamageMult().modifyMult(id, 2f);
        }
    }

    @Override
    public void unapply(MutableShipStatsAPI stats, String id) {
        stats.getMaxSpeed().unmodify(id);
        stats.getAcceleration().unmodify(id);
        stats.getDeceleration().unmodify(id);
        stats.getBallisticRoFMult().unmodify(id);
        stats.getMissileRoFMult().unmodify(id);
        stats.getEnergyRoFMult().unmodify(id);
        stats.getShieldAbsorptionMult().unmodify(id);
        stats.getShieldArcBonus().unmodify(id);
        stats.getShieldDamageTakenMult().unmodify(id);
        stats.getShieldTurnRateMult().unmodify(id);
        stats.getShieldUnfoldRateMult().unmodify(id);
        stats.getShieldUpkeepMult().unmodify(id);
        stats.getBeamWeaponDamageMult().unmodify(id);
    }

    @Override
    public StatusData getStatusData(int index, State state, float effectLevel) {
        if (index == 0) {
            return new StatusData("2x shield/engine strength, 1.3x weapon power", false);
        } 
        return null;
    }
}
