package com.fs.starfarer.api.campaign.econ;

import java.awt.Color;
import java.util.List;
import java.util.Map;


public interface MarketConditionPlugin {
	
	void init(MarketAPI market);
	void apply(String id);
	void unapply(String id);
	
	
	/**
	 * Only used for conditions that come from events.
	 * @return
	 */
	List<String> getRelatedCommodities();
	
	
	/**
	 * For the description that shows up in the tooltip.
	 * @return
	 */
	Map<String, String> getTokenReplacements();
	
	/**
	 * For the description, which is shown in the tooltip.
	 * @return
	 */
	String [] getHighlights();
	Color [] getHighlightColors();
	
	void setParam(Object param);
}
