package com.fs.starfarer.api.combat;

import java.util.List;

import com.fs.starfarer.api.loading.FormationType;
import com.fs.starfarer.api.loading.WingRole;

public interface FighterWingAPI {

	public static class ReturningFighter {
		public ShipAPI fighter;
		public FighterLaunchBayAPI bay;
		public ReturningFighter(ShipAPI fighter, FighterLaunchBayAPI bay) {
			this.fighter = fighter;
			this.bay = bay;
		}
	}
	
	/**
	 * Whether this fighter should be returning to a carrier.
	 * @param fighter
	 * @return
	 */
	boolean isReturning(ShipAPI fighter);
	
	/**
	 * Which launch bay the fighter should be returning to, if it's returning.
	 * @param fighter
	 * @return
	 */
	FighterWingAPI.ReturningFighter getReturnData(ShipAPI fighter);
	
	
	int getWingOwner();
	void setWingOwner(int owner);
	
	List<ShipAPI> getWingMembers();
	
	WingRole getRole();
	FormationType getFormation();

	boolean isDestroyed();

	String getWingId();

	boolean isAlly();
}
