package com.fs.starfarer.api.impl.campaign.econ;

import com.fs.starfarer.api.impl.campaign.ids.Commodities;

public class Dissident extends BaseMarketConditionPlugin {
	
	public void apply(String id) {
		market.getCommodityData(Commodities.GREEN_CREW).getSupply().modifyMult(id, ConditionData.DISSIDENT_CREW_MULT);
		
		float pop = getPopulation(market);
		market.getDemand(Commodities.HAND_WEAPONS).getDemand().modifyFlat(id, Math.max(10f, pop * ConditionData.DISSIDENT_WEAPONS_MULT));
		market.getDemand(Commodities.MARINES).getDemand().modifyFlat(id, pop * ConditionData.DISSIDENT_MARINES_MULT);
		
		market.getStability().modifyFlat(id, ConditionData.STABILITY_DISSIDENT, "Dissident population");
	}

	public void unapply(String id) {
		market.getCommodityData(Commodities.GREEN_CREW).getSupply().unmodify(id);
		
		market.getDemand(Commodities.HAND_WEAPONS).getDemand().unmodify(id);
		market.getDemand(Commodities.MARINES).getDemand().unmodify(id);
		
		market.getStability().unmodify(id);
	}

}
