package com.fs.starfarer.api.impl.campaign.shared;

import java.util.ArrayList;
import java.util.List;

import com.fs.starfarer.api.impl.campaign.ids.Factions;

public class PersonBountyEventData {

	private List<String> participatingFactions = new ArrayList<String>();
	
	private int level = 0;
	private int successesThisLevel = 0;
	private int numOngoing = 0;

	public PersonBountyEventData() {
		addParticipatingFaction(Factions.HEGEMONY);
		addParticipatingFaction(Factions.DIKTAT);
		addParticipatingFaction(Factions.LUDDIC_CHURCH);
		addParticipatingFaction(Factions.TRITACHYON);
		addParticipatingFaction(Factions.INDEPENDENT);
	}

	public void reportStarted() {
		numOngoing++;
	}
	
	public void reportEnded() {
		numOngoing--;
		if (numOngoing < 0) numOngoing = 0;
	}
	
	public void reportSuccess() {
		successesThisLevel++;
		
		if (successesThisLevel >= 3) {
			level++;
			successesThisLevel = 0;
		}
		if (level > 10) level = 10;
	}
	public int getLevel() {
		//if (true) return 10;
		return level;
	}

	public int getNumOngoing() {
		return numOngoing;
	}

	public List<String> getParticipatingFactions() {
		return participatingFactions;
	}
	
	public void addParticipatingFaction(String factionId) {
		participatingFactions.add(factionId);
	}
	
	public boolean isParticipating(String factionId) {
		return participatingFactions.contains(factionId);
	}
}

